<?php
/**
 * Plugin CILIEN
 * Copyright (c) Christophe IMBERTI
 * Licence Creative commons by-nc-sa
 */

if (!defined("_ECRIRE_INC_VERSION")) return;

include_spip('inc/actions');
include_spip('inc/editer');
include_spip('inc/cilien');


function formulaires_cilien_remplacer_domaine_charger_dist(){

	$valeurs = array();
	
	if (!autoriser('configurer', 'configuration'))
		return;

	$valeurs['ciedit'] = true;

	return $valeurs;
}


function formulaires_cilien_remplacer_domaine_verifier_dist(){
        $erreurs = array();

	if (_request('domaineinitial')){
            if (!_request('domainefutur')){
		$erreurs['domainefutur'] = _T('info_obligatoire');
            } else {
                if (!cilien_verifier_domaine(_request('domaineinitial')))
                    $erreurs['domaineinitial'] =  _T('cidomaine:valeur_incorrecte');
                elseif (!cilien_verifier_domaine(_request('domainefutur')))
                    $erreurs['domainefutur'] =  _T('cidomaine:valeur_incorrecte');
                elseif (sql_countsel("spip_cilien", "url LIKE '%"._request('domaineinitial')."%'")==0)
                    $erreurs['domaineinitial'] =  _T('cilien:domaine_existe_pas');
            }
        }

	return $erreurs;
}


function formulaires_cilien_remplacer_domaine_traiter_dist(){
        $cibreak = false;
        $compte = 0;
        $res = array();

        // remplacer un domaine
	if (_request('domaineinitial') AND _request('domainefutur')){
            $domaineinitial = _request('domaineinitial');
            $domainefutur = _request('domainefutur');
            
            $result = sql_select("*", "spip_cilien", "url LIKE '%".$domaineinitial."%'");
            $dureemax = 10;	// duree maximum en secondes
            $time = time();
                
            while ($row = sql_fetch($result)) {
                $n = cilien_remplace_dans_objet($domaineinitial,$domainefutur,$row['objet'],$row['id_objet']);
                if ($n>=1)
                    $compte++;
                
                sql_updateq("spip_cilien", array("url"=>str_replace($domaineinitial,$domainefutur,$row['url'])), "url='".$row['url']."' AND objet='".$row['objet']."' AND id_objet=".$row['id_objet']);
                
                // si plus de dureemax secondes on sort de la boucle
                if ((time() - $time) > $dureemax){
                    $cibreak = true;
                    break;
                }
            }
            
            // traiter aussi les sites references
            $result = sql_select("*", "spip_syndic", "url_site LIKE '%".$domaineinitial."%'");
            while ($row = sql_fetch($result)) {
                sql_updateq("spip_syndic", array("url_site"=>str_replace($domaineinitial,$domainefutur,$row['url_site']), "url_syndic"=>str_replace($domaineinitial,$domainefutur,$row['url_syndic'])), "id_syndic=".$row['id_syndic']);
                $compte++;
            }
            
            if (defined('_DIR_PLUGIN_CITRACE')){
                if ($citrace = charger_fonction('citrace', 'inc')) {
                    include_spip('inc/texte');
                    $message = '(remplacement du domaine '.$domaineinitial.' par '.$domainefutur.')';							
                    $citrace('lien', '', 'remplacer lien', $message);
                }
            }
           
        }
        
        if ($cibreak){
            	$res['domaineinitial'] = _request('domaineinitial');
            	$res['domainefutur'] = _request('domainefutur');
        	$res['message_ok'] = 'Remplacement fait dans '.$compte.' objet(s). <span style="color:red; font-weight:bold;">Traitement partiel. Relancer le traitement.</font>';
        } else {
        	$res['message_ok'] = 'Remplacement fait dans '.$compte.' objet(s)';
        }
        
	return $res;	
}

?>